  
"
    __________________________________________________
    @Alejandro F. Reimondo 27/03/98
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"
    (File pathName: 'LibJPEG.Pol') fileIn;close.
!

Dynalink32 variableByteSubclass: #JPEGDLL32
  classVariableNames: ''
  poolDictionaries: 
    ' JPEGConstants ' !

PictureBitmap subclass: #JPEGImage
  instanceVariableNames: 
    ' drawDIB '
  classVariableNames: ''
  poolDictionaries: 
    ' JPEGConstants '  !


!JPEGDLL32 class methods !
   
callbackTable
    " Private - Returns the callback shape table for defining callback handlers."

    ^#(
    "(callBackName (arguments...) returnType callingConvertion)"

    (errorExit (ulong ) none api) "Error exit handler: does not return to caller."
    (emitMessage (ulong long) none api) "Conditionally emit a trace or warning message."
    (outputMessage (ulong) none api) "Routine that actually outputs a trace or error message."
    (formatMessage (ulong) none api) "Format a message string for the most recent JPEG error or message."
    (resetErrorManager (ulong) none api) "Reset error state variables at start of a new image."

    )!
 
fileName
    "Private - Answer the receiver's file name."

     ^'LibJPEG.Dll'!
  
initializeConstants
   "Private - Initializes the constants for the interface...
        JPEGDLL32 initializeConstants.
    "

    JPEGConstants size = 0 ifTrue: [
        JPEGConstants := Dictionary new
    ].

  JPEGConstants
    at: 'CMaxBlocksInMcu' put: 10;
    at: 'CstateRawOk' put: 102;
    at: 'CstateScanning' put: 101;
    at: 'CstateStart' put: 100;
    at: 'CstateWrcoefs' put: 103;
    at: 'Dctsize' put: 8;
    at: 'Dctsize2' put: 64;
    at: 'DMaxBlocksInMcu' put: 10;
    at: 'DstateBufimage' put: 207;
    at: 'DstateBufpost' put: 208;
    at: 'DstateInheader' put: 201;
    at: 'DstatePreload' put: 203;
    at: 'DstatePrescan' put: 204;
    at: 'DstateRawOk' put: 206;
    at: 'DstateRdcoefs' put: 209;
    at: 'DstateReady' put: 202;
    at: 'DstateScanning' put: 205;
    at: 'DstateStart' put: 200;
    at: 'DstateStopping' put: 210;
    at: 'JbufCrankDest' put: 2;
    at: 'JbufPassThru' put: 0;
    at: 'JbufSaveAndPass' put: 3;
    at: 'JbufSaveSource' put: 1;
    at: 'JcsCmyk' put: 4;
    at: 'JcsGrayscale' put: 1;
    at: 'JcsRgb' put: 2;
    at: 'JcsUnknown' put: 0;
    at: 'JcsYcbcr' put: 3;
    at: 'JcsYcck' put: 5;
    at: 'JdctFloat' put: 2;
    at: 'JdctIfast' put: 1;
    at: 'JdctIslow' put: 0;
    at: 'JditherFs' put: 2;
    at: 'JditherNone' put: 0;
    at: 'JditherOrdered' put: 1;
    at: 'JpegApp0' put: 224;
    at: 'JpegCom' put: 254;
    at: 'JpegEoi' put: 217;
    at: 'JpegHeaderOk' put: 1;
    at: 'JpegHeaderTablesOnly' put: 2;
    at: 'JpegLibVersion' put: 61;
    at: 'JpegRst0' put: 208;
    at: 'JpegSuspended' put: 0;
    at: 'JpoolImage' put: 1;
    at: 'JpoolNumpools' put: 2;
    at: 'JpoolPermanent' put: 0;
    at: 'MaxCompsInScan' put: 4;
    at: 'MaxSampFactor' put: 4;
    at: 'NumArithTbls' put: 16;
    at: 'NumHuffTbls' put: 4;
    at: 'NumQuantTbls' put: 4;
    yourself.!
 
initializeInternalStructures
    "Private - Initializes the internal structures for the interfase.
    JPEGDLL32 initializeStructures
    "

    self
        registerType: 'jpeg_comp_master'
        as:#(
			(prepareForPass ulong asExternalAddress)
			(passStartup ulong asExternalAddress)
			(finishPass ulong asExternalAddress)
			(callPassStartup boolean)
			(isLastPass boolean)
		);
        registerType: 'jpeg_c_main_controller'
        as:#(
			(startPass ulong asExternalAddress)
			(processData ulong asExternalAddress)
		);
        registerType: 'jpeg_c_prep_controller'
        as:#(
			(startPass ulong asExternalAddress)
			(preProcessData ulong asExternalAddress)
		);
        registerType: 'jpeg_c_coef_controller'
        as:#(
			(startPass ulong asExternalAddress)
			(compressData ulong asExternalAddress)
		);
        registerType: 'jpeg_color_converter'
        as:#(
			(startPass ulong asExternalAddress)
			(colorConvert ulong asExternalAddress)
		);
        registerType: 'jpeg_downsampler'
        as:#(
			(startPass ulong asExternalAddress)
			(downsample ulong asExternalAddress)
			(needContextRows boolean)
		);
        registerType: 'jpeg_forward_dct'
        as:#(
			(startPass ulong asExternalAddress)
			(forwardDCT ulong asExternalAddress)
		);
        registerType: 'jpeg_entropy_encoder'
        as:#(
			(startPass ulong asExternalAddress)
			(encodeMcu ulong asExternalAddress)
			(finishPass ulong asExternalAddress)
		);
        registerType: 'jpeg_marker_writer'
        as:#(
			(writeAnyMarker ulong asExternalAddress)
			(writeFileHeader ulong asExternalAddress)
			(writeFrameHeader ulong asExternalAddress)
			(writeScanHeader ulong asExternalAddress)
			(writeFileTrailer ulong asExternalAddress)
			(writeTablesOnly ulong asExternalAddress)
		);
        registerType: 'jpeg_decomp_master'
        as:#(
			(prepareForOutputPass ulong asExternalAddress)
			(finishOutputPass ulong asExternalAddress)
			(isDummyPass boolean)
		);
        registerType: 'jpeg_input_controller'
        as:#(
			(consumeInput ulong asExternalAddress)
			(resetInputController ulong asExternalAddress)
			(startInputPass ulong asExternalAddress)
			(finishInputPass ulong asExternalAddress)
			(hasMultipleScans boolean)
			(eoiReached boolean)
		);
        registerType: 'jpeg_d_main_controller'
        as:#(
			(startPass ulong asExternalAddress)
			(processData ulong asExternalAddress)
		);
        registerType: 'jpeg_d_coef_controller'
        as:#(
			(startInputPass ulong asExternalAddress)
			(consumeData ulong asExternalAddress)
			(startOutputPass ulong asExternalAddress)
			(decompressData ulong asExternalAddress)
			(coefArrays ulong asExternalAddress)
		);
        registerType: 'jpeg_d_post_controller'
        as:#(
			(startPass ulong asExternalAddress)
			(postProcessData ulong asExternalAddress)
		);
        registerType: 'jpeg_marker_reader'
        as:#(
			(resetMarkerReader ulong asExternalAddress)
			(readMarkers ulong asExternalAddress)
			(readRestartMarker ulong asExternalAddress)
			(processAPPn (16 ulong))
			(sawSOI boolean)
			(sawSOF boolean)
			(nextRestartNum long)
			(discardedBytes ulong)
		);
        registerType: 'jpeg_entropy_decoder'
        as:#(
			(startPass ulong asExternalAddress)
			(decodeMCU ulong asExternalAddress)
		);
        registerType: 'jpeg_inverse_dct'
        as:#(
			(startPass ulong asExternalAddress)
			(inverseDCT (10 ulong))
		);
        registerType: 'jpeg_upsampler'
        as:#(
			(startPass ulong asExternalAddress)
			(upsample ulong asExternalAddress)
			(needContextRows boolean)
		);
        registerType: 'jpeg_color_deconverter'
        as:#(
			(startPass ulong asExternalAddress)
			(colorConvert ulong asExternalAddress)
		);
        registerType: 'jpeg_color_quantizer'
        as:#(
			(startPass ulong asExternalAddress)
			(colorQuantize ulong asExternalAddress)
			(finishPass ulong asExternalAddress)
			(newColorMap ulong asExternalAddress)
		);
        yourself.!

initializeStructures
    "Private - Initializes the structures for the interfase.
    JPEGDLL32 initializeStructures.
	SelfDefinedStructure definitions inspect.
    "

    self
        initializeInternalStructures;
        registerType: 'JQUANT_TBL'
        as:#(
            (quantval (64 word))
            (sentTable boolean)
        );
        registerType: 'JHUFF_TBL'
        as:#(
            (bits (17 byte))
            (huffval (256 byte))
            (sentTable boolean)
        );
        registerType: 'jpeg_component_info'
        as:#(
            (componentId long)
            (componentIndex long)
            (hSampFactor long)
            (vSampFactor long)
            (quantTblNo long)
            (dcTblNo long)
            (acTblNo long)
            (widthInBlocks ulong)
            (heightInBlocks ulong)
            (dctScaledSize long)
            (downsampledWidth ulong)
            (downsampledHeight ulong)
            (componentNeeded boolean)
            (mcuWidth long)
            (mcuHeight long)
            (mcuBlocks long)
            (mcuSampleWidth long)
            (lastColWidth long)
            (lastRowHeight long)
            (quantTable '*JQUANT_TBL')
            (dctTable ulong asExternalAddress)
        );
        registerType: 'jpeg_scan_info'
        as:#(
            (compsInScan long)
            (componentIndex (4  long))
            (ss long) (se long)
            (ah long) (al long)
        );
        registerType: 'jpeg_common_struct'
        as:#(
            (err '*jpeg_error_mgr')
            (mem '*jpeg_memory_mgr')
            (progress '*jpeg_progress_mgr')
            (isDecompressor boolean)
            (globalState long)
        );
        registerType: 'jpeg_compress_struct'
        as:#(
            (err '*jpeg_error_mgr')
            (mem '*jpeg_memory_mgr')
            (progress '*jpeg_progress_mgr')
            (isDecompressor boolean)
            (globalState long)
            (dest '*jpeg_destination_mgr')
            (imageWidth ulong)
            (imageHeight ulong)
            (inputComponents long)
            (inColorSpace ulong)
            (inputGamma 8"double")
            (dataPrecision long)
            (numComponents long)
            (jpegColorSpace long)
            (compInfo '*jpeg_component_info')
            (quantTblPtrs (4 '*JQUANT_TBL'))
            (dcHuffTblPtrs (4 '*JHUFF_TBL'))
            (acHuffTblPtrs (4 '*JHUFF_TBL'))
            (arithDcL (16 byte))
            (arithDcU (16 byte))
            (arithAcK (16 byte))
            (numScans long)
            (scanInfo '*jpeg_scan_info')
            (rawDataIn boolean)
            (arithCode boolean)
            (optimizeCoding boolean)
            (ccir601Sampling boolean)
            (smoothingFactor long)
            (dctMethod ulong)
            (restartInterval ulong)
            (restartInRows long)
            (writeJFIFHeader boolean)
            (densityUnit ushort)
            (xDensity ushort)
            (yDensity ushort)
			(dust ulong)
            (writeAdobeMarker boolean)
            (nextScanline ulong)
            (progressiveMode boolean)
            (maxHSampFactor long)
            (maxVSampFactor long)
            (totalIMCURows ulong)
            (compsInScan long)
            (curCompInfo (4 '*jpeg_component_info'))
            (mcusPerRow ulong)
            (mcuRowsInScan ulong)
            (blocksInMCU long)
            (mcuMembership (10 long))
            (ss long) (se long)
            (ah long) (al short)
            (master '*jpeg_comp_master')
            (main '*jpeg_c_main_controller')
            (prep '*jpeg_c_prep_controller')
            (coef '*jpeg_c_coef_controller')
            (marker '*jpeg_marker_writer')
            (cconvert '*jpeg_color_converter')
            (downsample '*jpeg_downsampler')
            (fdct '*jpeg_forward_dct')
            (entropy '*jpeg_entropy_encoder')
        );
        registerType: 'coefBitsArray'
        as:#( (array 64 long) );
        registerType: 'jpeg_decompress_struct'
        as:#(
            (err '*jpeg_error_mgr')
            (mem '*jpeg_memory_mgr')
            (progress '*jpeg_progress_mgr')
            (isDecompressor boolean)
            (globalState long)
            (src '*jpeg_source_mgr')
            (imageWidth ulong)
            (imageHeight ulong)
            (numComponents long)
            (jpegColorSpace ulong)
            (outColorSpace ulong)
            (scaleNum ulong)
            (scaleDenom ulong)
            (outputGamma 8"double")
			(dust ulong)
            (bufferedImage boolean)
            (rawDataOut boolean)
            (dctMethod ulong)
            (doFancyUpsampling boolean)
            (doBlockSmoothing boolean)
            (quantizeColors boolean)
            (ditherMode ulong)
            (twoPassQuantize boolean)
            (desiredNumberOfColors long)
            (enable1passQuant boolean)
            (enableExternalQuant boolean)
            (enable2passQuant boolean)
            (outputWidth ulong)
            (outputHeight ulong)
            (outColorComponents long)
            (outputComponents long)
            (recOutbufHeight long)
            (actualNumberOfColors long)
            (colormap ulong asExternalAddress)
            (outputScanline long)
            (inputScanNumber long)
            (inputIMCURow ulong)
            (outputScanNumber long)
            (outputIMCURow ulong)
            (coefBits '*coefBitsArray')
			(quantTblPtrs (4 '*JQUANT_TBL'))
            (dcHuffTblPtrs (4 '*JHUFF_TBL'))
            (acHuffTblPtrs (4 '*JHUFF_TBL'))
            (dataPrecision long)
            (compinfo '*jpeg_component_info')
            (progressiveMode boolean)
            (arithCode boolean)
            (arithDcL (16 byte))
            (arithDcU (16 byte))
            (arithAcK (16 byte))
            (restartInterval ulong)
            (sawJFIFMarker boolean)
            (densityUnit byte)
            (dust2 byte)
            (xDensity ushort)
            (yDensity ushort)
            (sawAdobeMarker ushort asBoolean)
            (adobeTransform byte)
            (dust3 (7 byte))
            (ccir601Sampling  boolean)
            (maxHSampFactor long)
            (maxVSampFactor long)
            (minDCTScaledSize long)
            (totalIMCURows ulong)
            (sampleRangeLimit '*JSAMPLE')
            (compsInScan long)
            (curCompInfo (4 '*jpeg_component_info'))
            (mcusPerRow ulong)
            (mcuRowsInScan ulong)
            (blocksInMCU long)
            (mcuMembership (10 long))
            (ss long) (se long)
            (ah long) (al long)
            (unreadMarker long)
            (master '*jpeg_decomp_master')
            (main '*jpeg_c_main_controller')
            (coef '*jpeg_d_post_controller')
            (post '*jpeg_marker_writer')
            (inputctl '*jpeg_input_controller')
            (marker '*jpeg_marker_reader')
            (entropy '*jpeg_entropy_encoder')
            (idct '*jpeg_inverse_dct')
            (upsample '*jpeg_upsampler')
            (cconvert '*jpeg_color_deconverter')
            (cquantize '*jpeg_color_quantizer')
			(dust4 long)
        );
        registerType: 'msg_parm'
        as:#(
            "(i (8 ulong)) comparten la misma direccin"
            (s 80 asString)
        );
        registerType: 'jpeg_error_mgr'
        as:#(
            (errorExit ulong asExternalAddress)
            (emitMessage ulong asExternalAddress)
            (outputMessage ulong asExternalAddress)
            (formatMessage ulong asExternalAddress)
            (resetErrorMgr ulong asExternalAddress)
            (msgCode long)
            (msgParm 'msg_parm')
            (traceLevel long)
            (numWarnings long)
            (jpegMessageTable ulong asExternalAddress)
            (lastJpegMessage short)
            (addonMessageTtable ulong asExternalAddress)
            (firstAddonMessage long)
            (lastAddonMessage long)
        );
        registerType: 'jpeg_progress_mgr'
        as:#(
            (progressMonitor ulong asExternalAddress)
            (passCounter long)
            (passLimit long)
            (completedPasses long)
            (totalPasses long)
        );
        registerType: 'jpeg_destination_mgr'
        as:#(
            (nextOutputByte ulong asExternalAddress)
            (freeInBuffer ulong)
            (initDestination ulong asExternalAddress)
            (emptyOutputBuffer ulong asExternalAddress)
            (termDestination ulong asExternalAddress)
        );
        registerType: 'jpeg_memory_mgr'
        as:#(
            (allocSmall ulong asExternalAddress)
            (allocLarge ulong asExternalAddress)
            (allocSarray ulong asExternalAddress)
            (allocBarray ulong asExternalAddress)
            (requestVirtSarray ulong asExternalAddress)
            (requestVirtBarray ulong asExternalAddress)
            (realizeVirtArrays ulong asExternalAddress)
            (accessVirtSarray ulong asExternalAddress)
            (accessVirtBarray ulong asExternalAddress)
            (freePool ulong asExternalAddress)
            (selfDestruct ulong asExternalAddress)
            (maxMemoryToUse long)
        );
        yourself.!
 
newCallBack: callBackName sending: selector to: aReceiver
    "Returns a CallBack object for sending message with selector to aReceiver.
    callBackName must be a valid name defined in callbackTable."

    | tuple aMessage parameterTypes |
    tuple := self callbackTable
        detect: [:one| one first = callBackName ]
        ifNone: [ ^self error: 'Invalid callback name.'].

    "check selector arguments with parameterTypes size"
    parameterTypes := tuple at: 2.
    (selector asString select: [:c| c = $: ]) size = parameterTypes size
    ifFalse: [ ^self error: 'Invalid selector (Must have ',parameterTypes size asString,' arguments.' ].

    aMessage := Message new
        receiver: aReceiver;
        selector: selector;
        yourself.
    ^CallBack
        registerMessage: aMessage
        parameterTypes: parameterTypes
        returnType: (tuple at: 3)
        callingConvention: (tuple size > 3 ifTrue: [ tuple at: 4 ] ifFalse: [#api]).
! !



!JPEGDLL32 methods !
 
abort: commonPtr
	"Generic version of jpeg_abort that work on either flavor of JPEG object.  May be more convenient in some places."

    <api: jpeg_abort struct none>
    ^self invalidArgument!
  
abortCompress: compressPtr
	"If you choose to abort compression before completing jpeg_finish_(de)compress, then you need to clean up to release memory,
	 temporary files, etc.  You can just call jpeg_destroy_(de)compress if you're done with the JPEG object, but if you want to clean it up and reuse it, call this."

    <api: jpeg_abort_compress struct none>
    ^self invalidArgument!
 
abortDecompress: deCompressPtr
	"If you choose to abort decompression before completing jpeg_finish_(de)compress, then you need to clean up to release memory,
	 temporary files, etc.  You can just call jpeg_destroy_(de)compress if you're done with the JPEG object, but if you want to clean it up and reuse it, call this."

    <api: jpeg_abort_decompress struct none>
    ^self invalidArgument!
 
addQuantTable: compressPtr
	whichTbl: whichTbl
	basicTable: ushortPtr
	scaleFactor: scaleFactor
	forceBaseline: aBoolean
	""
    <api: jpeg_add_quant_table struct short ulong short boolean none>
    ^self invalidArgument!

allocHuffTable: commonPtr
	"
	Returns: JHUFF_TBL *
	"
    <api: jpeg_alloc_huff_table struct ulongReturn>
    ^self invalidArgument!
   
allocQuantTable: commonPtr
	"
	Returns: JQUANT_TBL *
	"
    <api: jpeg_alloc_quant_table struct ulongReturn>
    ^self invalidArgument!

calcOutputDimensions: deCompressPtr
	"Precalculate output dimensions for current decompression parameters."

    <api: jpeg_calc_output_dimensions struct none>
    ^self invalidArgument!
  
closeFile: pFile
	"Close a data stream."

    <api: jpeg_close_file ulong none>
    ^self invalidArgument!
  
consumeInput: deCompressPtr
	"
	Return value is one of:
		JPEG_SUSPENDED=0    Suspended due to lack of input data
		JPEG_REACHED_SOS=1 Reached start of new scan
		JPEG_REACHED_EOI=2 Reached end of image
		JPEG_ROW_COMPLETED=3 Completed one iMCU row
		JPEG_SCAN_COMPLETED=4 Completed last iMCU row of a scan
	"

    <api: jpeg_consume_input struct short>
    ^self invalidArgument!
 
copyCriticalParameters: compressPtr to: destCompressPtr
	"Copy raw DCT coefficients --- useful for lossless transcoding."

    <api: jpeg_copy_critical_parameters struct struct none>
    ^self invalidArgument!
   
createCompress: jpegCompressStruct
	" Initialization of JPEG compression object.
	 WARNING: you must set up the error-manager BEFORE calling createCompress.
	"

	^self
		createCompress: jpegCompressStruct asParameter
		version: self version
		structSize: jpegCompressStruct sizeInBytes!
  
createCompress: compressPtr  version: version structSize: structSize
	" Initialization of JPEG compression objects.
	 WARNING: you must set up the error-manager BEFORE calling createCompress.
	"
    <api: jpeg_CreateCompress struct ushort ushort none>
    ^self invalidArgument!
 
createDecompress: jpegDecompressStruct
	"Initialization of JPEG decompression object.
	 WARNING: you must set up the error-manager BEFORE calling createDecompress.
	"

	^self
		createDecompress: jpegDecompressStruct asParameter
		version: self version
		structSize: jpegDecompressStruct sizeInBytes!
 
createDecompress: deCompressPtr version: version structSize: structSize
	""
    <api: jpeg_CreateDecompress struct ushort ushort none>
    ^self invalidArgument!

defaultColorsSpace: compressPtr
	""
    <api: jpeg_default_colorspace struct none>
    ^self invalidArgument!

destroy: commonPtr
	"Generic version of jpeg_destroy that work on either flavor of JPEG object.  May be more convenient in some places."

    <api: jpeg_destroy ulong none>
    ^self invalidArgument!
 
destroyCompress: compressPtr
	"Generic version of jpeg_destroy that work on either flavor of JPEG object.  May be more convenient in some places."

    <api: jpeg_destroy_compress struct none>
    ^self invalidArgument!
 
destroyDecompress: deCompressPtr
	""
    <api: jpeg_destroy_decompress struct none>
    ^self invalidArgument!
   
finishCompress: compressPtr
	"Compression Finished..."

    <api: jpeg_finish_compress struct none>
    ^self invalidArgument!
  
finishDecompress: deCompressPtr
	""
    <api: jpeg_finish_decompress struct boolean>
    ^self invalidArgument!
  
finishOutput: deCompressPtr
	""
    <api: jpeg_finish_output struct boolean>
    ^self invalidArgument!
  
hasMultipleScans: deCompressPtr
	""
    <api: jpeg_has_multiple_scans struct boolean>
    ^self invalidArgument!
 
inputComplete: deCompressPtr
	""
    <api: jpeg_input_complete struct boolean>
    ^self invalidArgument!

newColormap: deCompressPtr
	""
    <api: jpeg_new_colormap struct none>
    ^self invalidArgument!
   
qualityScaling: quality
	""
    <api: jpeg_quality_scaling short short>
    ^self invalidArgument!
   
readCoefficients: deCompressPtr
	"Read raw DCT coefficients --- useful for lossless transcoding."

    <api: jpeg_read_coefficients struct ulongReturn>
    ^self invalidArgument!
  
readHeader: deCompressPtr
	"Decompression startup: read start of JPEG datastream to see what's there."

    ^self readHeader: deCompressPtr requireImage: true!
  
readHeader: deCompressPtr requireImage: aBoolean
	"Decompression startup: read start of JPEG datastream to see what's there.
	Return value is one of:
		JPEG_SUSPENDED=0 Suspended due to lack of input data
		JPEG_HEADER_OK=1 Found valid image datastream
		JPEG_HEADER_TABLES_ONLY=2 Found valid table-specs-only datastream
	If you pass require_image = TRUE (normal case), you need not check for
	a TABLES_ONLY return code; an abbreviated file will cause an error exit.
	JPEG_SUSPENDED is only possible if you use a data source module that can
	give a suspension return (the stdio source module doesn't).
	"

    <api: jpeg_read_header struct boolean short>
    ^self invalidArgument!
  
readRawData: deCompressPtr data: jSampImage maxLines: anInteger
	"Replaces jpeg_read_scanlines when reading raw downsampled data."

    <api: jpeg_read_raw_data struct struct ushort ushort>
    ^self invalidArgument!

readScanlines: deCompressPtr scanlines: jSampArray maxLines: anInteger
	"Read som scanlines into a buffer."

    <api: jpeg_read_scanlines struct struct ushort ushort>
    ^self invalidArgument!
  
resyncToRestart: deCompressPtr desired: anInteger
	"Default restart-marker-resync procedure for use by data source modules."

    <api: jpeg_resync_to_restart struct short boolean>
    ^self invalidArgument!
 
setColorsSpace: compressPtr colorSpace: colorSpace
	""
    <api: jpeg_set_colorspace struct ushort none>
    ^self invalidArgument!
  
setDefaults: compressPtr
	"Compression parameter setup with default values.
	You must set at least #inColorSpace: before calling this since the defaults depends on it."

    <api: jpeg_set_defaults struct none>
    ^self invalidArgument!
  
setLinearQuality: compressPtr scaleFactor: scaleFactor forceBaseline: forceBaseline
	"Compression parameter setup aids."

    <api: jpeg_set_linear_quality struct short boolean none>
    ^self invalidArgument!
   
setMarkerProcessor: deCompressPtr
	markerCode: anInteger
	routine: jpegMarkerParserMethod
	"Install a special processing method for COM or APPn markers."

    <api: jpeg_set_marker_processor struct short ulong none>
    ^self invalidArgument!

setQuality: compressPtr quality: quality forceBaseline: forceBaseline
	"Compression parameter setup aids."

    <api: jpeg_set_quality struct short boolean none>
    ^self invalidArgument!

simpleProgression: compressPtr
	""
    <api: jpeg_simple_progression struct none>
    ^self invalidArgument!
 
startCompress: compressPtr writeAllTables: aBoolean
	"Start compression..."

    <api: jpeg_start_compress struct boolean none>
    ^self invalidArgument!
  
startDecompress: deCompressPtr
	"Start decompressor."

    <api: jpeg_start_decompress struct boolean>
    ^self invalidArgument!
   
startOutput: deCompressPtr scanNumber: anInteger
	""
    <api: jpeg_start_output struct short boolean>
    ^self invalidArgument!

stdError: jpegErrorMgr
	"Default error-management setup."
    <api: jpeg_std_error struct ulongReturn>
    ^self invalidArgument!

stdioDest: compressPtr outFile: outFile
	"Standard data source and destination managers: stdio streams.
	Caller is responsible for opening the file before and closing after."

    <api: jpeg_stdio_dest struct ulong none>
    ^self invalidArgument!

stdioDest: compressPtr pathName: pathName
	"Standard data source and destination managers: stdio streams.
	Caller is responsible for opening the file before and closing after."

    <api: jpeg_stdio_dest_path struct struct ulongReturn>
    ^self invalidArgument!
 
stdioSrc: decompressPtr inFile: inFile
	"Standard data source and destination managers: stdio streams.
	Caller is responsible for opening the file before and closing after."

    <api: jpeg_stdio_src struct ulong none>
    ^self invalidArgument!
  
stdioSrc: decompressPtr pathName: pathName
	"Standard data source and destination managers: stdio streams.
	Caller is responsible for opening the file before and closing after."

    <api: jpeg_stdio_src_path struct struct ulongReturn>
    ^self invalidArgument!
 
suppressTables: compressPtr suppress: aBoolean
	""
    <api: jpeg_suppress_tables struct boolean none>
    ^self invalidArgument!

version
	"Returns version of this component."

	^61 "Version 6a"!

writeCoefficients: compressPtr coefArrays: jvirtBarrayPtr
	"Write raw DCT coefficients --- useful for lossless transcoding."

    <api: jpeg_write_coefficients struct struct none>
    ^self invalidArgument!
  
writeMarker: compressPtr marker: anInteger dataPtr: joctetPtr dataLen: ushort
	"Write a special marker."

    <api: jpeg_write_marker struct short struct ushort none>
    ^self invalidArgument!
   
writeRawData: compressPtr data: jSampImage numLines: anInteger
	"Replaces jpeg_write_scanlines when writing raw downsampled data."

    <api: jpeg_write_raw_data struct struct ushort ushort>
    ^self invalidArgument!
   
writeScanlines: compressPtr scanlines: jSampArray numLines: anInteger
	"write a scanLine of image data."

    <api: jpeg_write_scanlines struct struct ushort ushort>
    ^self invalidArgument!

writeTables: compressPtr
	"Alternate compression function: just write an abbreviated table file."

    <api: jpeg_write_tables struct none>
    ^self invalidArgument! !



!JPEGImage class methods !
  
allFilters
    "Private - Returns the filter specifications for all image files supported by the receiver.
	This method can be refined by subclasses..."

    ^ #(
        ('*.jpg;*.jpeg' 'JPEG Files (*.JPG)')
    )!
   
jpegErrors
    " Private - Returns the errors strings."

    ^#(
    'Bogus message code %d'
    'Sorry, there are legal restrictions on arithmetic coding'
    'ALIGN_TYPE is wrong, please fix'
    'MAX_ALLOC_CHUNK is wrong, please fix'
    'Bogus buffer control mode'
    'Invalid component ID %d in SOS'
    'IDCT output block size %d not supported'
    'Bogus input colorspace'
    'Bogus JPEG colorspace'
    'Bogus marker length'
    'Wrong JPEG library version: library is %d, caller expects %d'
    'Sampling factors too large for interleaved scan'
    'Invalid memory pool code %d'
    'Unsupported JPEG data precision %d'
    'Invalid progressive parameters Ss=%d Se=%d Ah=%d Al=%d'
    'Invalid progressive parameters at scan script entry %d'
    'Bogus sampling factors'
    'Invalid scan script at entry %d'
    'Improper call to JPEG library in state %d'
    'JPEG parameter struct mismatch: library thinks size is %u, caller expects %u'
    'Bogus virtual array access'
    'Buffer passed to JPEG library is too small'
    'Suspension not allowed here'
    'CCIR601 sampling not implemented yet'
    'Too many color components: %d, max %d'
    'Unsupported color conversion request'
    'Bogus DAC index %d'
    'Bogus DAC value 0x%x'
    'Bogus DHT counts'
    'Bogus DHT index %d'
    'Bogus DQT index %d'
    'Empty JPEG image (DNL not supported)'
    'Read from EMS failed'
    'Write to EMS failed'
    'Didnt expect more than one scan'
    'Input file read error'
    'Output file write error --- out of disk space?'
    'Fractional sampling not implemented yet'
    'Huffman code size table overflow'
    'Missing Huffman code table entry'
    'Maximum supported image dimension is %u pixels'
    'Empty input file'
    'Premature end of input file'
    'Cannot transcode due to multiple use of quantization table %d'
    'Scan script does not transmit all data'
    'Invalid color quantization mode change'
    'Not implemented yet'
    'Requested feature was omitted at compile time'
    'Backing store not supported'
    'Huffman table 0x%02x was not defined'
    'JPEG datastream contains no image'
    'Quantization table 0x%02x was not defined'
    'Not a JPEG file: starts with 0x%02x 0x%02x'
    'Insufficient memory (case %d)'
    'Cannot quantize more than %d color components'
    'Cannot quantize to fewer than %d colors'
    'Cannot quantize to more than %d colors'
    'Invalid JPEG file structure: two SOF markers'
    'Invalid JPEG file structure: missing SOS marker'
    'Unsupported JPEG process: SOF type 0x%02x'
    'Invalid JPEG file structure: two SOI markers'
    'Invalid JPEG file structure: SOS before SOF'
    'Failed to create temporary file %s'
    'Read failed on temporary file'
    'Seek failed on temporary file'
    'Write failed on temporary file --- out of disk space?'
    'Application transferred too few scanlines'
    'Unsupported marker type 0x%02x'
    'Virtual array controller messed up'
    'Image too wide for this implementation'
    'Read from XMS failed'
    'Write to XMS failed'
    'JCOPYRIGHT'
    'JVERSION'
    'Caution: quantization tables are too coarse for baseline JPEG'
    'Adobe APP14 marker: version %d, flags 0x%04x 0x%04x, transform %d'
    'Unknown APP0 marker (not JFIF), length %u'
    'Unknown APP14 marker (not Adobe), length %u'
    'Define Arithmetic Table 0x%02x: 0x%02x'
    'Define Huffman Table 0x%02x'
    'Define Quantization Table %d  precision %d'
    'Define Restart Interval %u'
    'Freed EMS handle %u'
    'Obtained EMS handle %u'
    'End Of Image'
    '        %3d %3d %3d %3d %3d %3d %3d %3d'
    'JFIF APP0 marker, density %dx%d  %d'
    'Warning: thumbnail image size does not match data length %u'
    'Unknown JFIF minor revision number %d.%02d'
    '    with %d x %d thumbnail image'
    'Skipping marker 0x%02x, length %u'
    'Unexpected marker 0x%02x'
    '        %4u %4u %4u %4u %4u %4u %4u %4u'
    'Quantizing to %d = %d*%d*%d colors'
    'Quantizing to %d colors'
    'Selected %d colors for quantization'
    'At marker 0x%02x, recovery action %d'
    'RST%d'
    'Smoothing not supported with nonstandard sampling ratios'
    'Start Of Frame 0x%02x: width=%u, height=%u, components=%d'
    '    Component %d: %dhx%dv q=%d'
    'Start of Image'
    'Start Of Scan: %d components'
    '    Component %d: dc=%d ac=%d'
    '  Ss=%d, Se=%d, Ah=%d, Al=%d'
    'Closed temporary file %s'
    'Opened temporary file %s'
    'Unrecognized component IDs %d %d %d, assuming YCbCr'
    'Freed XMS handle %u'
    'Obtained XMS handle %u'
    'Unknown Adobe color transform code %d'
    'Inconsistent progression sequence for component %d coefficient %d'
    'Corrupt JPEG data: %u extraneous bytes before marker 0x%02x'
    'Corrupt JPEG data: premature end of data segment'
    'Corrupt JPEG data: bad Huffman code'
    'Warning: unknown JFIF revision number %d.%02d'
    'Premature end of JPEG file'
    'Corrupt JPEG data: found marker 0x%02x instead of RST%d'
    'Invalid SOS parameters for sequential JPEG'
    'Application transferred too many scanlines'
    'JMSG_LASTMSGCODE'
	)!

jpegLibrary
    " Private - Returns the JPEG library."

    ^JPEGDLL32 current!
  
saveDIB: aDIB
	as: pathName
	quality: qualityFactor

	"Save aDIB as a TIF file named pathName with qualityFactor.
	Returns the instance used for saving."

	^self new
		pathName: pathName;
		saveDIB: aDIB quality: qualityFactor;
		yourself!
   
test
    "Test the receiver displaying an image onto display.
    TIFFImage test
    "

    | image |
    image := self fromUser.
    image notNil ifTrue: [
        image asDIB inspect.
        image release.
    ].! !



!JPEGImage methods !

asBitmap
    "Returns the receiver as a Bitmap."

    ^self asDIB asBitmap!
  
asDIB
    "Returns the receiver as a DIB."

    hImage isNil ifFalse: [ ^hImage ].
	hImage := self decompressDIB.
	^hImage!

boundingBox
    "Returns the receiver's boundingBox"

	| box |
	self withDecompressInfoDo: [:cinfo|
		box := 0@0 extent: cinfo imageWidth @ cinfo imageHeight
	].
    ^box!
  
colorTableFrom: cinfo
    " Private - Returns a color table from a  cinfo decompression information."

    | size colorTable stream total index |
    size := WinBitmapInfo colorTableSize: cinfo outputComponents * 8.
    size = 0 ifTrue: [ ^nil ].
    colorTable := ByteArray new: size.
    stream := WriteStream on: colorTable.
    total := size // 4.
    0 to: total - 1 do: [:i| "only grayScale bitmaps are supported."
        index := i * 256 // total.
        stream next: 3 put: index;nextPut: 0.
    ].
    ^colorTable!
  
copyToClipboard
    "Copies the receiver to the Clipboard"

    ^self asBitmap
		copyToClipboard;
		release!
   
decompressDIB
    " Private - Try to decompress the receiver as a DIB from storage unaltered."

    ^self decompressDIB: nil!

decompressDIB: outColorSpace
    " Private - Try to decompress the receiver as a DIB from storage
	with a defined color space."

    | cinfo jerr input outputMessage errorExit externalJerr
      rowStride bufferAddress aDIB index step bitsStream
      outputComponents |
    step := 1. "number of scanLines transferred per read."
    cinfo := self structureNamed: 'jpeg_decompress_struct'.
    jerr := self jpegStandardError.
    outputMessage := self outputMessageCallback.
    errorExit := self errorExitCallback.
    jerr
        outputMessage: outputMessage asParameter;
        errorExit: errorExit asParameter;
        yourself.
    [
        externalJerr := self externalStructureNamed: 'jpeg_error_mgr'.
        jerr copyToAddress: externalJerr contents.
        cinfo err: externalJerr contents contents.
        self jpegLibrary createDecompress: cinfo.
        input := self jpegLibrary
            stdioSrc: cinfo asParameter
            pathName: self pathName asParameter.
        input = 0 ifTrue: [ self error: 'Can''t open input file ',pathName ].
        (JpegHeaderOk = (self jpegLibrary readHeader: cinfo asParameter))
        ifFalse: [ self error: 'Invalid Header for Jpeg file ',pathName ].
		outColorSpace notNil ifTrue: [
			cinfo outColorSpace: outColorSpace
		].
        (self jpegLibrary startDecompress: cinfo asParameter)
        ifFalse: [ self error: 'Can''t start decompressor.' ].
        outputComponents := cinfo outputComponents.
        rowStride := cinfo outputWidth * outputComponents.
        aDIB := self dibFrom: cinfo.
        bitsStream := WriteStream on: aDIB bits.
        bufferAddress := ExternalAddress allocateMemory: rowStride.
        [ index  := cinfo outputScanline.
          index < cinfo outputHeight]
        whileTrue: [
            self jpegLibrary
                readScanlines: cinfo asParameter
                scanlines: bufferAddress asParameter
                maxLines: step.
            self
                storeScanLine: bufferAddress
                size: step * rowStride
                into: bitsStream
                outputComponents: outputComponents.
        ].
        bufferAddress release.
        aDIB bits: (self reversedBitsOf: aDIB).
        self jpegLibrary finishDecompress: cinfo asParameter
    ] ensure: [
        self jpegLibrary destroyCompress: cinfo asParameter.
        input notNil ifTrue: [ self jpegLibrary closeFile: input asParameter ].
        externalJerr notNil ifTrue: [ externalJerr releaseContents ].
        outputMessage release.
        errorExit release.
        cinfo releaseContents.
    ].
    ^aDIB!
 
decompressGrayDIB
    " Private - Try to decompress the receiver as a gray DIB from storage."

    ^self decompressDIB: JcsGrayscale!

defaultEmitMessage: aCommonPtrAddress with: msgLevel
    " Private - Default emitMessage handler.
	 Conditionally emit a trace or warning message. "

    msgLevel >= 0
	ifTrue: [
		self defaultOutputMessage: aCommonPtrAddress
	]
	ifFalse: [
		(Smalltalk at: #Transcript ifAbsent: [^self]) cr;show: 'Emit Message ...'
	].!
 
defaultErrorExit: aCommonPtrAddress
    " Private - Default error exit handler.
	  Error exit handler: does not return to caller. "

	| cinfo |
	cinfo := self
		structureNamed: 'jpeg_common_struct'
		at: aCommonPtrAddress asExternalAddress.
	self defaultOutputMessage: aCommonPtrAddress.
	self jpegLibrary destroy: cinfo asParameter.
    self error: (self
        messageTextFor: (self class jpegErrors at: cinfo err msgCode +1)
        with: (self messageArgumentsFrom: cinfo err msgParm))!
 
defaultOutputMessage: aCommonPtrAddress
    " Private - Default outputMessage handler.
     Routine that actually outputs a trace or error message. "

    | cinfo text |
    cinfo := self
        structureNamed: 'jpeg_common_struct'
        at: aCommonPtrAddress asExternalAddress.
    text := self
        messageTextFor: (self class jpegErrors at: cinfo err msgCode +1)
        with: (self messageArgumentsFrom: cinfo err msgParm).
    MessageBox message: 'Output Message code: ', cinfo err msgCode asString
        ,'\'withCrs, text!

dibFrom: cinfo
    " Private - Returns aDIB capable to store cinfo decompression information."

    | bitmapInfo bitCount bytes colorTable |
    bitCount := cinfo outputComponents * 8.
    (#(8 24) includes: bitCount) ifFalse: [ self notImplementedYet ].
    bitmapInfo := WinBitmapInfo
        width: cinfo outputWidth
        height: cinfo outputHeight
        planes: 1
        bitCount: bitCount.
    bitCount ~= 24 ifTrue: [
        colorTable := self colorTableFrom: cinfo.
        bitmapInfo colorTable: colorTable
    ].
    bitmapInfo sizeImage = 0
    ifTrue: [
        bytes := bitmapInfo width * bitmapInfo bitCount + 31 // 32 * 4 * bitmapInfo height
    ] ifFalse: [ bytes := bitmapInfo sizeImage ].
    ^DIB new
        bitmapInfo: bitmapInfo;
        bits: (ByteArray new: bytes)!

displayAt: aPoint with: aPen
    "Display the receiver with aPen at aPoint."

	| displaySource |
    self isValid ifFalse: [^nil].
	displaySource := self drawDIB isNil
	ifTrue: [ self asDIB ]
	ifFalse: [ self drawDIB ].
    ^displaySource displayAt: aPoint with: aPen!

drawDIB
    "Returns the instance var of the receiver
     for external manipulation"

	drawDIB isNil ifTrue: [ self initializeDrawDIB ].
    ^drawDIB!

drawDIB: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    drawDIB := anObject!
 
emitMessageCallback
    " Private - Returns a callback object for processing emitMessage behavior.
	  Conditionally emit a trace or warning message. "

    ^self errorExitCallbackSending: #defaulEmitMessage:with: to: self!
  
emitMessageCallbackSending: selector to: aReceiver
    " Private - Returns a callback object for processing emitMessage behavior.
	  Conditionally emit a trace or warning message. "

    ^self
        newCallBack: #emitMessage
        sending: selector
        to: aReceiver.!
 
errorExitCallback
    " Private - Returns a callback object for processing errorExit behavior.
	  Error exit handler: does not return to caller. "

    ^self errorExitCallbackSending: #defaultErrorExit: to: self!

errorExitCallbackSending: selector to: aReceiver
    " Private - Returns a callback object for processing errorExit behavior.
	  Error exit handler: does not return to caller. "

    ^self
        newCallBack: #errorExit
        sending: selector
        to: aReceiver.!
   
externalStructureNamed: aSDSName
    "Returns the structure named aName or nil if absent...
    This method is recomended for building SDStructures..."

    ^self jpegLibrary externalStructureNamed: aSDSName!

fileInFrom: aPathName format: aFormat
    "Private - Read the receiver internal structure from aFile.
    aFormat will be ignored."

    self pathName: aPathName!
  
flip: bits by: scanLineSize
    " Private - Flip the vertically the bits by scanLineSize."

    | buffer j |
    j := bits size.
    buffer := ByteArray new: scanLineSize.
    1 to: bits size - scanLineSize // 2 by: scanLineSize do: [:i|
        j := j - scanLineSize.
        buffer replaceFrom: 1 to: scanLineSize with: bits startingAt: i.
        bits
            replaceFrom: i to: i + scanLineSize - 1 with: bits startingAt: j + 1;
            replaceFrom: j + 1 to: j + scanLineSize with: buffer startingAt: 1
    ].
	^bits!
 
height
    "Returns the receiver's height"

    ^self boundingBox height!

initializeDrawDIB
	" Private - Initializes the receiver's drawDIB"

	drawDIB := (Smalltalk includesKey: #DrawDIBImage)
		ifTrue: [ (Smalltalk at: #DrawDIBImage) fromDIB: self asDIB ]!
 
isValid
    "True if the receiver is valid..."

    ^self pathName notNil!
   
jpegLibrary
    " Private - Returns the JPEG library."

    ^self class jpegLibrary!
 
jpegStandardError
	" Private - Returns the JPeg standard error handler. "

	| jerr |
	jerr := self structureNamed: 'jpeg_error_mgr'.
	self jpegLibrary stdError: jerr asParameter.
	^jerr!

messageArgumentsFrom: msgParm
    " Private - Returns the arguments in msgParm. "

    | result stream |
	stream := ReadWriteStream on: msgParm s.
	result := OrderedCollection new.
	"stream next;next."
	[stream atEnd] whileFalse: [
		[ result add: stream nextULong ] on: Error do: [].
	].
	^result asArray!

messageTextFor: descriptor with: arguments
    " Private - Returns a scanned text description replaced with arguments. "

    | count token selector input output |
    input := ReadStream on: descriptor.
    output := WriteStream on: String new.
    selector := $%. count := 1.
    [input atEnd] whileFalse: [
        output nextPutAll: (input upTo: selector).
        input atEnd ifFalse: [
            token := input next.
            "token = $d ifTrue: [ " output nextPutAll: (arguments at: count) asString "]".
            count := count + 1.
        ].
    ].
    ^output contents!
  
newCallBack: callBackName sending: selector to: receiver
    " Private - Returns a valid callback to process with selector."

    ^self jpegLibrary class
        newCallBack: callBackName
        sending: selector
        to: receiver!
   
outputMessageCallback
    " Private - Returns a callback object for processing outputMessage behavior.
	  Routine that actually outputs a trace or error message. "

    ^self errorExitCallbackSending: #defaultOutputMessage: to: self!
   
outputMessageCallbackSending: selector to: aReceiver
    " Private - Returns a callback object for processing outputMessage behavior.
	  Routine that actually outputs a trace or error message. "

    ^self
        newCallBack: #outputMessage
        sending: selector
        to: aReceiver.!
  
outputToPrinter
    "Print the receiver on the system printer."

    ^self outputToPrinter: nil!
 
outputToPrinter: aPrinterOrName
    "Print the receiver on the printer."

    ^self asBitmap
		outputToPrinter: aPrinterOrName;
		release!
 
release
    "Release the receiver's resources..."

    drawDIB release.
    super release.!
 
reversedBitsOf: aDIB
    "Private - Revert the image bits of aDIB."

    ^self
		flip: aDIB bits copy
		by: (self scanLineSizeOf: aDIB)
!
 
saveAs: aFileName format: aFormat
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

	self species new
		saveDIB: self asDIB
		quality: nil!
  
saveDIB: aDIB quality: quality
	" Private - Save the receiver from aDIB with a quality factor."

	| cinfo jerr output externalJerr outputMessage errorExit scanLineAddress |
	cinfo := self structureNamed: 'jpeg_compress_struct'.
	jerr := self jpegStandardError.
	outputMessage := self outputMessageCallback.
	errorExit := self errorExitCallback.
	jerr
		outputMessage: outputMessage asParameter;
		errorExit: errorExit asParameter;
		yourself.
	[
		externalJerr := self externalStructureNamed: 'jpeg_error_mgr'.
		jerr copyToAddress: externalJerr contents.
		cinfo err: externalJerr contents contents.
		self jpegLibrary createCompress: cinfo.
		output := self jpegLibrary
			stdioDest: cinfo asParameter
			pathName: self pathName asParameter.
		output = 0 ifTrue: [ self error: 'Can''t open output file ',pathName ].
		cinfo
			imageWidth: aDIB width;
			imageHeight: aDIB height;
			inputComponents: 3;	"number of components per pixel."
			inColorSpace: JcsRgb;	"color space of input image."
			yourself.
		self jpegLibrary setDefaults: cinfo asParameter.
		quality notNil ifTrue: [
			self jpegLibrary 
				setQuality: cinfo asParameter
				quality: quality forceBaseline: true.
		].
		self jpegLibrary
			startCompress: cinfo asParameter
			writeAllTables: true.
		self
			withScanLinesOf: aDIB
			do: [:scanLine|
				scanLineAddress := scanLine copyToExternalMemory.
				cinfo nextScanline < cinfo imageHeight
				ifTrue: [
					self jpegLibrary
						writeScanlines: cinfo asParameter
						scanlines: scanLineAddress asParameter
						numLines: 1.
				].
				scanLineAddress release.
			].
		self jpegLibrary finishCompress: cinfo asParameter
	] ensure: [
		self jpegLibrary destroyCompress: cinfo asParameter.
		output notNil ifTrue: [ self jpegLibrary closeFile: output asParameter ].
		externalJerr notNil ifTrue: [ externalJerr releaseContents ].
		outputMessage release.
		errorExit release.
		cinfo releaseContents.
	].!
  
scanLineSizeOf: aDIB
    "Private - Rturns the scan line size of aDIB."

    | bitmapInfo |
    bitmapInfo := aDIB bitmapInfo.
    ^bitmapInfo sizeImage = 0
    ifTrue: [ ((bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4 ]
    ifFalse: [ bitmapInfo sizeImage // bitmapInfo height ]!
   
storeScanLine: bufferAddress size: size into: bitsStream outputComponents: outputComponents
    " Private - Store bytes from buffer into bits stream.
    bitStream is a 24Bits DIB bits ByteArray."

    | holder input red green blue |
    holder := ByteArray new: size + 3 // 4 * 4.
    holder replaceBytes: size with: bufferAddress.
    outputComponents = 3
    ifTrue: [ "must flip color components for DIBs."
        input := ReadStream on: holder.
       size // 3 timesRepeat: [
            blue := input next. green := input next. red := input next.
            bitsStream nextPut: red;nextPut: green;nextPut: blue
        ].
		[input atEnd] whileFalse: [ bitsStream nextPut: input next ].
    ]
    ifFalse: [
        bitsStream nextPutAll: holder
    ]!
  
structureNamed: aSDSName
    "Returns the structure named aName or nil if absent...
    This method is recomended for building SDStructures..."

    ^self jpegLibrary structureNamed: aSDSName!

structureNamed: aSDSName at: anAddress
    "Returns the structure named aName or nil if absent...
    This method is recomended for building SDStructures..."

    ^(self jpegLibrary structureNamed: aSDSName)
		contents: anAddress;
		yourself!

width
    "Returns the receiver's width"

    ^self boundingBox width!
   
withDecompressInfoDo: aBlock
    " Private - Evaluates aBlock (one argument block) with the decompress info of the receiver."

    | cinfo jerr input outputMessage errorExit externalJerr result |
    cinfo := self structureNamed: 'jpeg_decompress_struct'.
    jerr := self jpegStandardError.
    outputMessage := self outputMessageCallback.
    errorExit := self errorExitCallback.
    jerr
        outputMessage: outputMessage asParameter;
        errorExit: errorExit asParameter;
        yourself.
    [
        externalJerr := self externalStructureNamed: 'jpeg_error_mgr'.
        jerr copyToAddress: externalJerr contents.
        cinfo err: externalJerr contents contents.
        self jpegLibrary createDecompress: cinfo.
        input := self jpegLibrary
            stdioSrc: cinfo asParameter
            pathName: self pathName asParameter.
        input = 0 ifTrue: [ self error: 'Can''t open input file ',pathName ].
        (JpegHeaderOk = (self jpegLibrary readHeader: cinfo asParameter))
        ifFalse: [ self error: 'Invalid Header for Jpeg file ',pathName ].
		result := aBlock value: cinfo.
    ] ensure: [
        self jpegLibrary destroyCompress: cinfo asParameter.
        input notNil ifTrue: [ self jpegLibrary closeFile: input asParameter ].
        externalJerr notNil ifTrue: [ externalJerr releaseContents ].
        outputMessage release.
        errorExit release.
        cinfo releaseContents.
    ].
    ^result!

withScanLinesOf: aDIB do: aBlock
	" Private - Evaluates aBlock with RGB scanLines obtained from aDIB. "

	| bitCount stream scanLine bits width red green blue
	 palette colorTable align index hi lo |
	width := aDIB width.
	bitCount := aDIB bitCount.
	colorTable := aDIB colorTable.
	bits := ReadStream on: (self reversedBitsOf: aDIB).
	scanLine := ByteArray new: width * 3.
	[bits atEnd] whileFalse: [
		stream := WriteStream on: scanLine.
		bitCount = 24 ifTrue: [ "24 bits DIB => BGR values."
			width timesRepeat: [
				blue := bits next. green := bits next. red := bits next.
				stream nextPut: red;nextPut: green;nextPut: blue
			].
		].
		bitCount = 8 ifTrue: [ "8 bits paletized values."
			width timesRepeat: [
				index := bits next.
				blue := colorTable at: index * 4 + 1.
				green := colorTable at: index * 4 + 2.
				red := colorTable at: index * 4 + 3.
				stream nextPut: red;nextPut: green;nextPut: blue.
			].
    		align := 4 - (width \\ 4). "Number of byte added at the end of each line of the DIB"
    		align == 4 ifTrue: [ align := 0 ].
			align timesRepeat: [ bits next ].
		].
		bitCount = 4 ifTrue: [ "4 bits paletized values."
			self notFullyImplemented.
			1 to: width // 2 do: [:i|
				index := bits next.
				blue := colorTable at: index \\ 16 * 4 + 1.
				green := colorTable at: index \\ 16 * 4 + 2.
				red := colorTable at: index \\ 16 * 4 + 3.
				stream nextPut: red;nextPut: green;nextPut: blue.
				i * 2 <= width ifTrue: [
					blue := colorTable at: index // 16 * 4 + 1.
					green := colorTable at: index // 16 * 4 + 2.
					red := colorTable at: index // 16 * 4 + 3.
					stream nextPut: red;nextPut: green;nextPut: blue.
				].
			].
    		align := 4 - (width \\ 4). "Number of byte added at the end of each line of the DIB"
    		align == 4 ifTrue: [ align := 0 ].
			align timesRepeat: [ bits next ].
		].
		bitCount = 1 ifTrue: [ "monocrome image."
			self notImplementedYet
		].

		aBlock value: scanLine.
	].! !
